## rz-ghidra 0.6.0

=== ghidra/CMakeLists.txt ===

################################################################################
# see Ghidra/Features/Decompiler/build.gradle in Ghidra source

# Base of everything
set(SOURCE_BASE_CXX
		# xml.cc				// generated by yacc task
		marshal.cc
		space.cc
		float.cc
		address.cc
		pcoderaw.cc
		translate.cc
		opcodes.cc
		globalcontext.cc)

set(SOURCE_BASE_YACC
		xml.y)

# For libdecomp used in rz-ghidra and ghidra's decompile executable
set(SOURCE_DECOMPILER_CXX
	capability.cc
	architecture.cc
	options.cc
	graph.cc
	cover.cc
	block.cc
	cast.cc
	typeop.cc
	database.cc
	cpool.cc
	comment.cc
	fspec.cc
	action.cc
	loadimage.cc
	# grammar.cc	 // doesn't seem to be used
	varnode.cc
	op.cc
	type.cc
	variable.cc
	varmap.cc
	jumptable.cc
	emulate.cc
	emulateutil.cc
	flow.cc
	userop.cc
	funcdata.cc
	funcdata_block.cc
	funcdata_varnode.cc
	unionresolve.cc
	funcdata_op.cc
	pcodeinject.cc
	heritage.cc
	prefersplit.cc
	rangeutil.cc
	ruleaction.cc
	subflow.cc
	blockaction.cc
	merge.cc
	double.cc
	coreaction.cc
	condexe.cc
	override.cc
	dynamic.cc
	crc32.cc
	prettyprint.cc
	printlanguage.cc
	printc.cc
	printjava.cc
	memstate.cc
	opbehavior.cc
	paramid.cc
	transform.cc
	string_ghidra.cc
	stringmanage.cc
	# callgraph.cc			// uncomment for debug
	# ifacedecomp.cc		// uncomment for debug
	# ifaceterm.cc			// uncomment for debug
	# interface.cc			// uncomment for debug
)

# libdecomp only
set(SOURCE_LIBDECOMP_CXX
		libdecomp.cc)

# specific to Ghidra's decompile executable
set(SOURCE_GHIDRA_CXX
		ghidra_process.cc
		ghidra_arch.cc
		loadimage_ghidra.cc
		typegrp_ghidra.cc
		database_ghidra.cc
		ghidra_context.cc
		cpool_ghidra.cc
		comment_ghidra.cc
		inject_ghidra.cc
		ghidra_translate.cc)


# for both rz-ghidra and sleighc
set(SOURCE_SLEIGH_CXX
		sleigh_arch.cc
		sleigh.cc
		inject_sleigh.cc
		filemanage.cc
		semantics.cc
		slghsymbol.cc
		context.cc
		sleighbase.cc
		slghpatexpress.cc
		slghpattern.cc
		pcodecompile.cc)

set(SOURCE_SLEIGH_YACC
		pcodeparse.y
		grammar.y)

# cli
set(SOURCE_CONSOLE_CXX
		consolemain.cc
		interface.cc
		ifacedecomp.cc
		testfunction.cc
		ifaceterm.cc
		callgraph.cc
		raw_arch.cc)

# sleighc
set(SLEIGH_COMPILER_SOURCE_CXX
		slgh_compile.cc
		slgh_compile.hh)

set(SLEIGH_COMPILER_SOURCE_YACC
		slghparse.y)

set(SLEIGH_COMPILER_SOURCE_FLEX
		slghscan.l)

set(SOURCE_DIR ghidra/Ghidra/Features/Decompiler/src/decompile/cpp)

################################################################################

function(prepend_src_dir list_name)
	set(tmp)
	foreach(r ${${list_name}})
		list(APPEND tmp "${SOURCE_DIR}/${r}")
	endforeach()
	set(${list_name} "${tmp}" PARENT_SCOPE)
endfunction()

prepend_src_dir(SOURCE_BASE_CXX)
prepend_src_dir(SOURCE_DECOMPILER_CXX)
prepend_src_dir(SOURCE_LIBDECOMP_CXX)
prepend_src_dir(SOURCE_GHIDRA_CXX)
prepend_src_dir(SOURCE_SLEIGH_CXX)
prepend_src_dir(SOURCE_CONSOLE_CXX)
prepend_src_dir(SLEIGH_COMPILER_SOURCE_CXX)

if(GENERATE_PARSERS)
	find_package(BISON REQUIRED)
	file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bison")
	find_package(FLEX REQUIRED)
	file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/flex")

	# build yacc files and append the output files to OUT_VAR
	macro(build_bison OUT_VAR)
		foreach(yacc_file ${ARGN})
			get_filename_component(yacc_name "${yacc_file}" NAME_WE)
			if("${yacc_name}" STREQUAL "slghparse")
				set(yacc_prefix yy)
			else()
				set(yacc_prefix "${yacc_name}")
			endif()
			if(BISON_VERSION VERSION_LESS 2.6)
				set(BISON_COMPILE_FLAGS "--name-prefix=${yacc_prefix}")
			else()
				set(BISON_COMPILE_FLAGS "-Dapi.prefix={${yacc_prefix}}")
			endif()
			BISON_TARGET(${yacc_name}
					"${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE_DIR}/${yacc_file}"
					"${CMAKE_CURRENT_BINARY_DIR}/bison/${yacc_name}.cpp"
					COMPILE_FLAGS ${BISON_COMPILE_FLAGS})
			list(APPEND ${OUT_VAR} "${BISON_${yacc_name}_OUTPUTS}")
		endforeach()
	endmacro()

	build_bison(SOURCE_BASE_CXX ${SOURCE_BASE_YACC})
	build_bison(SOURCE_SLEIGH_CXX ${SOURCE_SLEIGH_YACC})
	build_bison(SLEIGH_COMPILER_SOURCE_CXX ${SLEIGH_COMPILER_SOURCE_YACC})

	FLEX_TARGET(slghscan "${SOURCE_DIR}/${SLEIGH_COMPILER_SOURCE_FLEX}" "${CMAKE_CURRENT_BINARY_DIR}/flex/slghscan.cpp")
	list(APPEND SLEIGH_COMPILER_SOURCE_CXX "${CMAKE_CURRENT_BINARY_DIR}/flex/slghscan.cpp")
	file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/flex/slghparse.tab.hh" "#include \"../bison/slghparse.hpp\"")
else()
	list(APPEND SOURCE_BASE_CXX
		"${SOURCE_DIR}/xml.hh"
		"${SOURCE_DIR}/xml.cc")
	list(APPEND SOURCE_SLEIGH_CXX
		"${SOURCE_DIR}/pcodeparse.hh"
		"${SOURCE_DIR}/pcodeparse.cc"
		"${SOURCE_DIR}/grammar.hh"
		"${SOURCE_DIR}/grammar.cc")
	list(APPEND SLEIGH_COMPILER_SOURCE_CXX
		"${SOURCE_DIR}/slghparse.hh"
		"${SOURCE_DIR}/slghparse.cc"
		"${SOURCE_DIR}/slghscan.cc")
endif()

add_library(ghidra_base STATIC ${SOURCE_BASE_CXX})
target_include_directories(ghidra_base PUBLIC "${SOURCE_DIR}")
set_target_properties(ghidra_base PROPERTIES POSITION_INDEPENDENT_CODE ON)

add_library(ghidra_decompiler STATIC ${SOURCE_DECOMPILER_CXX})
target_link_libraries(ghidra_decompiler PUBLIC ghidra_base)
target_include_directories(ghidra_decompiler PUBLIC "${SOURCE_DIR}")
set_target_properties(ghidra_decompiler PROPERTIES POSITION_INDEPENDENT_CODE ON)

add_library(ghidra_sleigh STATIC ${SOURCE_SLEIGH_CXX})
target_link_libraries(ghidra_sleigh PUBLIC ghidra_base)
target_include_directories(ghidra_sleigh PUBLIC "${SOURCE_DIR}")
set_target_properties(ghidra_sleigh PROPERTIES POSITION_INDEPENDENT_CODE ON)

add_library(ghidra_libdecomp STATIC ${SOURCE_LIBDECOMP_CXX})
target_link_libraries(ghidra_libdecomp PUBLIC ghidra_decompiler ghidra_sleigh)
set_target_properties(ghidra_libdecomp PROPERTIES POSITION_INDEPENDENT_CODE ON)

# "decompile" executable as used by Ghidra
if(BUILD_DECOMPILE_EXECUTABLE)
	add_executable(ghidra_decompiler_exec ${SOURCE_GHIDRA_CXX})
	target_link_libraries(ghidra_decompiler_exec ghidra_decompiler)
	set_target_properties(ghidra_decompiler_exec PROPERTIES OUTPUT_NAME decompile)
endif()

if(BUILD_DECOMPILE_CLI_EXECUTABLE)
	add_executable(ghidra_decompiler_cli ${SOURCE_CONSOLE_CXX})
	target_link_libraries(ghidra_decompiler_cli ghidra_libdecomp)
	set_target_properties(ghidra_decompiler_cli PROPERTIES OUTPUT_NAME decompile_cli)
endif()

add_executable(sleighc ${SLEIGH_COMPILER_SOURCE_CXX})
target_link_libraries(sleighc ghidra_sleigh)
target_include_directories(sleighc PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/flex")

if(BUILD_SLASPECS)
	file(GLOB_RECURSE SLASPEC_FILES "ghidra/Ghidra/Processors/*.slaspec")
	file(GLOB_RECURSE CPEC_FILES "ghidra/Ghidra/Processors/*.cspec")
	file(GLOB_RECURSE LDEFS_FILES "ghidra/Ghidra/Processors/*.ldefs")
	file(GLOB_RECURSE PSPEC_FILES "ghidra/Ghidra/Processors/*.pspec")
	set(SLAFILES "")
	set(SLEIGH_BASE "${CMAKE_CURRENT_BINARY_DIR}/sleigh")
	file(MAKE_DIRECTORY "${SLEIGH_BASE}")
	foreach(slaspec ${SLASPEC_FILES})
		get_filename_component(sleigh_name "${slaspec}" NAME_WE)
		get_filename_component(sleigh_dir "${slaspec}" DIRECTORY)
		set(sla_file "${SLEIGH_BASE}/${sleigh_name}.sla")
		add_custom_command(OUTPUT "${sla_file}"
				COMMAND sleighc "${slaspec}" "${sla_file}"
				MAIN_DEPENDENCY "${slaspec}"
				WORKING_DIRECTORY "${sleigh_dir}"
				DEPENDS sleighc)
		list(APPEND SLAFILES "${sla_file}")
	endforeach()
	add_custom_target(sla ALL DEPENDS ${SLAFILES})
	set(SLEIGH_INSTALL_DEST "${RIZIN_INSTALL_PLUGDIR}/rz_ghidra_sleigh")
	install(FILES ${SLAFILES} ${CPEC_FILES} ${LDEFS_FILES} ${PSPEC_FILES} DESTINATION "${SLEIGH_INSTALL_DEST}")
	if(IS_ABSOLUTE "${SLEIGH_INSTALL_DEST}")
		set(SLEIGHHOME_DEFAULT "${SLEIGH_INSTALL_DEST}")
	else()
		set(SLEIGHHOME_DEFAULT "${CMAKE_INSTALL_PREFIX}/${SLEIGH_INSTALL_DEST}")
	endif()
else()
	unset(SLEIGHHOME_DEFAULT)
endif()
set(SLEIGHHOME_DEFAULT "${SLEIGHHOME_DEFAULT}" PARENT_SCOPE)

=== debian/changelog ===
rz-ghidra (0.6.0-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Fri, 08 Sep 2023 17:08:12 +0200

rz-ghidra (0.6.0-0kali1) kali-dev; urgency=medium

  * New upstream version 0.6.0
  * Add required version of rizin and rizin-cutter in build-dep
  * d/watch: download tarball with all sources
  * Update lintian-overrides
  * Add missing doc information

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 21 Aug 2023 16:29:39 +0200

rz-ghidra (0.5.0-0kali1) kali-dev; urgency=medium

  * New upstream version 0.5.0

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 09 Jun 2023 11:05:41 +0200

rz-ghidra (0.4.0-0kali3) kali-dev; urgency=medium

  * Add superficial test
  * Disable CI build for armel

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 12 Apr 2023 11:31:27 +0700

rz-ghidra (0.4.0-0kali2) kali-dev; urgency=medium

  * Fix architecture-specific path in d/rules

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 20 Mar 2023 13:10:04 +0700

rz-ghidra (0.4.0-0kali1) kali-dev; urgency=medium

  [ Daniele Faugiana ]
  * Initial release

  [ Arnaud Rebillout ]
  * Review and minor changes

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 20 Mar 2023 08:45:01 +0700

=== debian/control ===
Source: rz-ghidra
Section: misc
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libqt5svg5-dev,
 librizin-cutter-dev (>= 2.3.0),
 librizin-dev (>= 0.6.0),
 qtbase5-dev,
 rizin-cutter,
Standards-Version: 4.6.2
Homepage: https://github.com/rizinorg/rz-ghidra

Package: rz-ghidra
Architecture: amd64 arm64 armhf i386 mipsel
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ghidra decompiler and sleigh disassembler for rizin
 This is an integration of the Ghidra decompiler and Sleigh Disassembler
 for rizin. It is solely based on the decompiler part of Ghidra, which is
 written entirely in C++, so Ghidra itself is not required at all and the
 plugin can be built self-contained.

## rz-ghidra 0.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0...3.5)
set(PKG_CONFIG_USE_CMAKE_PREFIX_PATH True)

project(rz-ghidra)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

find_package(Rizin REQUIRED Core)

set(RIZIN_INSTALL_PLUGDIR "${Rizin_PLUGINDIR}" CACHE STRING "Directory to install rizin plugins into")

option(BUILD_CUTTER_PLUGIN "Build rz-ghidra plugin for Cutter" OFF)
option(BUILD_DECOMPILE_EXECUTABLE "Build \"decompile\" executable as used by Ghidra (not needed for rizin)" OFF)
option(BUILD_DECOMPILE_CLI_EXECUTABLE "Build REPL decompiler (not needed for rizin)" OFF)
option(BUILD_SLASPECS "Build Sleigh specs for architectures from Ghidra" ON)
option(BUILD_SLEIGH_PLUGIN "Build asm and analysis plugin to use sleigh as a disassembler in rizin" ON)
option(GENERATE_PARSERS "Re-generate all parsers with Bison/Flex instead of using pre-generated ones" OFF)

if (BUILD_CUTTER_PLUGIN)
	find_package(Cutter REQUIRED)
	set(CUTTER_INSTALL_PLUGDIR "${Cutter_USER_PLUGINDIR}" CACHE STRING "Directory to install Cutter plugin into")
endif()

if(CMAKE_VERSION VERSION_LESS "3.1")
	if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		add_definitions(-std=c++11)
	endif()
else()
	set(CMAKE_CXX_STANDARD 11)
endif()

add_subdirectory(ghidra)
add_subdirectory(third-party)

set(PUBLIC_HEADERS
		src/rz_ghidra.h)

set(CORE_SOURCE
		src/core_ghidra.cpp
		src/RizinArchitecture.cpp
		src/RizinArchitecture.h
		src/RizinLoadImage.cpp
		src/RizinLoadImage.h
		src/RizinScope.cpp
		src/RizinScope.h
		src/RizinTypeFactory.cpp
		src/RizinTypeFactory.h
		src/RizinCommentDatabase.cpp
		src/RizinCommentDatabase.h
		src/CodeXMLParse.h
		src/CodeXMLParse.cpp
		src/ArchMap.h
		src/ArchMap.cpp
		src/RizinPrintC.h
		src/RizinPrintC.cpp
		src/RzCoreMutex.h
		src/RzCoreMutex.cpp
		src/PrettyXmlEncode.h
		src/PrettyXmlEncode.cpp
		src/PcodeFixupPreprocessor.h
		src/PcodeFixupPreprocessor.cpp
		src/rz_ghidra.h
		src/rz_ghidra_internal.h)

if(BUILD_SLEIGH_PLUGIN)
set(ASM_SOURCE
		src/SleighAsm.h
		src/SleighAsm.cpp
		src/SleighInstruction.h
		src/SleighInstruction.cpp
		src/asm_ghidra.cpp)

set(ANALYSIS_SOURCE
		src/SleighAsm.h
		src/SleighAsm.cpp
		src/SleighInstruction.h
		src/SleighInstruction.cpp
		src/SleighAnalysisValue.h
		src/SleighAnalysisValue.cpp
		src/analysis_ghidra.cpp)
endif()

add_library(core_ghidra SHARED ${CORE_SOURCE})
target_link_libraries(core_ghidra ghidra_libdecomp)
target_link_libraries(core_ghidra pugixml)
target_link_libraries(core_ghidra Rizin::Core)
set_target_properties(core_ghidra PROPERTIES
		OUTPUT_NAME core_ghidra
		PREFIX "")

configure_file(
	${PROJECT_SOURCE_DIR}/rz_ghidra.pc.in
	${PROJECT_BINARY_DIR}/rz_ghidra.pc
	@ONLY)

if(BUILD_CUTTER_PLUGIN)
	add_subdirectory(cutter-plugin)
endif()


if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	string (REPLACE ";" " " LD_RPATH_STR "@loader_path")
else()
	string (REPLACE ";" " " LD_RPATH_STR "$ORIGIN")
endif()

if(BUILD_SLEIGH_PLUGIN)
add_library(asm_ghidra SHARED ${ASM_SOURCE})
target_link_libraries(asm_ghidra core_ghidra)
set_target_properties(asm_ghidra PROPERTIES
		OUTPUT_NAME asm_ghidra
		BUILD_RPATH "${LD_RPATH_STR}"
		INSTALL_RPATH "${LD_RPATH_STR}"
		PREFIX "")

add_library(analysis_ghidra SHARED ${ANALYSIS_SOURCE})
target_link_libraries(analysis_ghidra core_ghidra)
set_target_properties(analysis_ghidra PROPERTIES
		OUTPUT_NAME analysis_ghidra
		BUILD_RPATH "${LD_RPATH_STR}"
		INSTALL_RPATH "${LD_RPATH_STR}"
		PREFIX "")
endif()

if(SLEIGHHOME_DEFAULT)
	target_compile_definitions(core_ghidra PRIVATE "-DRZ_GHIDRA_SLEIGHHOME_DEFAULT=\"${SLEIGHHOME_DEFAULT}\"")
	if(BUILD_SLEIGH_PLUGIN)
		target_compile_definitions(asm_ghidra PRIVATE "-DRZ_GHIDRA_SLEIGHHOME_DEFAULT=\"${SLEIGHHOME_DEFAULT}\"")
		target_compile_definitions(analysis_ghidra PRIVATE "-DRZ_GHIDRA_SLEIGHHOME_DEFAULT=\"${SLEIGHHOME_DEFAULT}\"")
	endif()
endif()

if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
	set(CMAKE_INSTALL_LIBDIR lib CACHE PATH "Output directory for libraries.")
endif()

install(TARGETS core_ghidra DESTINATION "${RIZIN_INSTALL_PLUGDIR}")
if(BUILD_SLEIGH_PLUGIN)
install(TARGETS asm_ghidra DESTINATION "${RIZIN_INSTALL_PLUGDIR}")
install(TARGETS analysis_ghidra DESTINATION "${RIZIN_INSTALL_PLUGDIR}")
endif()
install(FILES ${PUBLIC_HEADERS} DESTINATION "${CMAKE_INSTALL_PREFIX}/include")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/rz_ghidra.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== cutter-plugin/CMakeLists.txt ===

set(SOURCE
		RzGhidraPlugin.h
		RzGhidraPlugin.cpp
		RzGhidraDecompiler.h
		RzGhidraDecompiler.cpp)

set(CMAKE_AUTOMOC ON)
add_library(rz_ghidra_cutter MODULE ${SOURCE})
target_link_libraries(rz_ghidra_cutter Cutter::Cutter)
target_link_libraries(rz_ghidra_cutter core_ghidra)
install(TARGETS rz_ghidra_cutter DESTINATION "${CUTTER_INSTALL_PLUGDIR}")

=== ghidra/CMakeLists.txt ===
--- 
+++ 
@@ -171,11 +171,6 @@
 			else()
 				set(yacc_prefix "${yacc_name}")
 			endif()
-			if(BISON_VERSION VERSION_LESS 2.6)
-				set(BISON_COMPILE_FLAGS "--name-prefix=${yacc_prefix}")
-			else()
-				set(BISON_COMPILE_FLAGS "-Dapi.prefix={${yacc_prefix}}")
-			endif()
 			BISON_TARGET(${yacc_name}
 					"${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE_DIR}/${yacc_file}"
 					"${CMAKE_CURRENT_BINARY_DIR}/bison/${yacc_name}.cpp"

=== test/Makefile ===

all: run

.PHONY: run
run: rizin-testbins
	rz-test -L db/extras

.PHONY: i
i: rizin-testbins
	rz-test -i db/extras

rizin-testbins:
	git clone https://github.com/rizinorg/rizin-testbins --depth 1 rizin-testbins

=== third-party/CMakeLists.txt ===
option(USE_SYSTEM_PUGIXML "Use system pugixml library" OFF)

if (USE_SYSTEM_PUGIXML)
	find_package(pugixml REQUIRED)
else()
	add_library(pugixml STATIC
			pugixml/src/pugiconfig.hpp
			pugixml/src/pugixml.cpp
			pugixml/src/pugixml.hpp)
	target_include_directories(pugixml PUBLIC pugixml/src)
	set_target_properties(pugixml PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

=== test/bins/Makefile ===

all:

.PHONY: clean
clean:
	rm -fv dectest32 dectest64 rec sharedReturn.o

dectest32: dectest.c types.h
	gcc -m32 -fno-pic -no-pie -fno-omit-frame-pointer -o dectest32 -O0 dectest.c

dectest32-sp: dectest.c types.h
	gcc -m32 -fno-pic -no-pie -fomit-frame-pointer -o dectest32-sp -O0 dectest.c

dectest64: dectest.c types.h
	gcc -m64 -fno-pic -no-pie -fno-omit-frame-pointer -o dectest64 -O0 dectest.c

dectest64-sp: dectest.c types.h
	gcc -m64 -fno-pic -no-pie -fomit-frame-pointer -o dectest64-sp -O0 dectest.c

rec: rec.c types_rec.h
	gcc -m64 -fno-pic -no-pie -fno-omit-frame-pointer -o rec -O0 rec.c

strings: strings.c
	gcc -m64 -fno-pic -no-pie -fno-omit-frame-pointer -o strings -O0 strings.c

sharedReturn.o: sharedReturn.c
	gcc -m64 -fno-pic -no-pie -fno-omit-frame-pointer -fno-inline -o sharedReturn.o -O2 -c sharedReturn.c

=== third-party/pugixml/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(pugixml VERSION 1.9)

option(BUILD_SHARED_AND_STATIC_LIBS "Build both shared and static libraries" OFF)
option(BUILD_SHARED_LIBS "Build shared instead of static library" OFF)
option(BUILD_TESTS "Build tests" OFF)
option(USE_VERSIONED_LIBDIR "Use a private subdirectory to install the headers and libs" OFF)
option(USE_POSTFIX "Use separate postfix for each configuration to make sure you can install multiple build outputs" OFF)

set(BUILD_DEFINES "" CACHE STRING "Build defines")

if(MSVC)
	option(STATIC_CRT "Use static CRT libraries" OFF)

	# Rewrite command line flags to use /MT if necessary
	if(STATIC_CRT)
		foreach(flag_var
				CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
				CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
			if(${flag_var} MATCHES "/MD")
				string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
			endif(${flag_var} MATCHES "/MD")
		endforeach(flag_var)
	endif()
endif()

# Pre-defines standard install locations on *nix systems.
include(GNUInstallDirs)
mark_as_advanced(CLEAR CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR)

set(HEADERS src/pugixml.hpp src/pugiconfig.hpp)
set(SOURCES src/pugixml.cpp)

if(DEFINED BUILD_DEFINES)
	foreach(DEFINE ${BUILD_DEFINES})
		add_definitions("-D" ${DEFINE})
	endforeach()
endif()

if(BUILD_SHARED_AND_STATIC_LIBS)
	set(LIBRARY pugixml-static pugixml-shared)
else()
	set(LIBRARY pugixml)
endif()

if(BUILD_SHARED_AND_STATIC_LIBS)
    add_library(pugixml-static STATIC ${HEADERS} ${SOURCES})
    add_library(pugixml-shared SHARED ${HEADERS} ${SOURCES})
else()
  if(BUILD_SHARED_LIBS)
    add_library(pugixml SHARED ${HEADERS} ${SOURCES})
  else()
    add_library(pugixml STATIC ${HEADERS} ${SOURCES})
  endif()
endif()

# Export symbols for shared library builds
if(BUILD_SHARED_AND_STATIC_LIBS AND MSVC)
	target_compile_definitions(pugixml-shared PRIVATE "PUGIXML_API=__declspec(dllexport)")
endif()

if(BUILD_SHARED_LIBS AND MSVC)
	target_compile_definitions(pugixml PRIVATE "PUGIXML_API=__declspec(dllexport)")
endif()

if(USE_VERSIONED_LIBDIR)
	# Install library into its own directory under LIBDIR
	set(INSTALL_SUFFIX /pugixml-${pugixml_VERSION})
endif()

foreach(TARGET ${LIBRARY})
	# Enable C++11 long long for compilers that are capable of it
	if(NOT ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STRLESS 3.1 AND ";${CMAKE_CXX_COMPILE_FEATURES};" MATCHES ";cxx_long_long_type;")
	  target_compile_features(${TARGET} PUBLIC cxx_long_long_type)
	endif()

	set_target_properties(${TARGET} PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

	target_include_directories(${TARGET} PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/src>
		$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}${INSTALL_SUFFIX}>)

	if(USE_POSTFIX)
		set_target_properties(${TARGET} PROPERTIES DEBUG_POSTFIX "_d" MINSIZEREL_POSTFIX "_m" RELWITHDEBINFO_POSTFIX "_r")
	endif()
endforeach()

install(TARGETS ${LIBRARY} EXPORT pugixml-config
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}${INSTALL_SUFFIX}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}${INSTALL_SUFFIX}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}${INSTALL_SUFFIX})
install(EXPORT pugixml-config DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pugixml)

configure_file(scripts/pugixml.pc.in ${PROJECT_BINARY_DIR}/pugixml.pc @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/pugixml.pc DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig)

if(BUILD_TESTS)
	file(GLOB TEST_SOURCES tests/*.cpp)
	file(GLOB FUZZ_SOURCES tests/fuzz_*.cpp)
	list(REMOVE_ITEM TEST_SOURCES ${FUZZ_SOURCES})

	add_executable(check ${TEST_SOURCES})
	if(BUILD_SHARED_AND_STATIC_LIBS)
		target_link_libraries(check pugixml-static)
	else()
		target_link_libraries(check pugixml)
	endif()
	add_custom_command(TARGET check POST_BUILD COMMAND check WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

=== ghidra/ghidra/GhidraDocs/GhidraClass/Debugger/Makefile ===

PANDOC=pandoc

default: all

%.html: %.md
	$(PANDOC) -B navhead.htm --section-divs --toc -c style.css -s --lua-filter=links-to-html.lua --syntax-definition=gdb_syntax.xml --syntax-definition=sleigh_syntax.xml --metadata title="Ghidra Debugger" $< -o $@

all: \
		A1-GettingStarted.html \
		A2-UITour.html \
		A3-Breakpoints.html \
		A4-MachineState.html \
		A5-Navigation.html \
		A6-MemoryMap.html \
		B1-RemoteTargets.html \
		B2-Emulation.html \
		B3-Scripting.html \
		B4-Modeling.html

clean:
	-rm *.html

=== debian/changelog ===
rz-ghidra (0.8.0-0kali1) kali-dev; urgency=medium

  [ Steev Klimaszewski ]
  * d/upstream: Add upstream metadata

  [ Sophie Brun ]
  * New upstream version 0.8.0
  * Update build-depends

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 07 May 2025 10:34:58 +0200

rz-ghidra (0.7.0-0kali1) kali-dev; urgency=medium

  * New upstream version 0.7.0
  * Update minimal version of librizin-dev
  * Update minimal required version of rizin-cutter

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 07 Mar 2024 14:05:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,22 @@
 Source: rz-ghidra
 Section: misc
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders: Daniele Faugiana <dani.faugiana@gmail.com>
 Rules-Requires-Root: no
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
- libqt5svg5-dev,
- librizin-cutter-dev (>= 2.3.0),
- librizin-dev (>= 0.6.0),
- qtbase5-dev,
+ libqt6svg6-dev,
+ librizin-cutter-dev (>= 2.4.0),
+ librizin-dev (>= 0.8.0),
+ qt6-5compat-dev,
+ qt6-base-dev,
  rizin-cutter,
 Standards-Version: 4.6.2
 Homepage: https://github.com/rizinorg/rz-ghidra
+Vcs-Browser: https://gitlab.com/kalilinux/packages/rz-ghidra
+Vcs-Git: https://gitlab.com/kalilinux/packages/rz-ghidra.git
 
 Package: rz-ghidra
 Architecture: amd64 arm64 armhf i386 mipsel

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --buildsystem=cmake --sourcedirectory=.

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_CUTTER_PLUGIN=ON \
	    -DBUILD_SLEIGH_PLUGIN=ON \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DRIZIN_INSTALL_PLUGDIR=/usr/lib/rizin/plugins \
	    -DCUTTER_INSTALL_PLUGDIR=/usr/lib/rizin/cutter/plugins/native

execute_after_dh_auto_install:
	rm -fr debian/rz-ghidra/usr/include
	rm -fr debian/rz-ghidra/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	rmdir --ignore-fail-on-non-empty debian/rz-ghidra/usr/lib/$(DEB_HOST_MULTIARCH)

=== debian/tests/control ===
Test-Command: rizin -q -c "e asm.arch=?" | grep -q "^ghidra$"
Depends: @, rizin
Restrictions: superficial

=== debian/watch ===
version=4
opts="\
dversionmangle=auto,\
uversionmangle=s{(\d)[\-]?(rc\d*)$}{$1~$2},\
filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,\
downloadurlmangle=s%/archive/refs/tags/(.*).tar.gz%/releases/download/$1/rz-ghidra-src-$1.tar.gz%\
" https://github.com/rizinorg/rz-ghidra/tags \
  (?:.*?/)?v@ANY_VERSION@@ARCHIVE_EXT@
